Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2920)
@@ -16,4 +16,6 @@
 !
 ! Copyright 2015-2018 Czech Technical University in Prague
+! Copyright 2015-2018 Institute of Computer Science of the 
+!                     Czech Academy of Sciences, Prague
 ! Copyright 1997-2018 Leibniz Universitaet Hannover
 !------------------------------------------------------------------------------!
@@ -26,4 +28,11 @@
 ! -----------------
 ! $Id$
+! Remove unused pcbl, npcbl from ONLY list
+! moh.hefny:
+! Fixed bugs introduced by new structures and by moving radiation interaction
+! into radiation_model_mod.f90.
+! Bugfix: usm data output 3D didn't respect directions
+! 
+! 2906 2018-03-19 08:56:40Z Giersch
 ! Local variable ids has to be initialized with a value of -1 in 
 ! usm_average_3d_data
@@ -217,17 +226,10 @@
 !> Further work:
 !> -------------
-!> 1. Reduce number of shape view factors by merging factors for distant surfaces
-!>    under shallow angles. Idea: Iteratively select the smallest shape view
-!>    factor by value (among all sources and targets) which has a similarly
-!>    oriented source neighbor (or near enough) SVF and merge them by adding
-!>    value of the smaller SVF to the larger one and deleting the smaller one.
-!>    This will allow for better scaling at higher resolutions.
-!>
-!> 2. Remove global arrays surfouts, surfoutl and only keep track of radiosity
+!> 1. Remove global arrays surfouts, surfoutl and only keep track of radiosity
 !>    from surfaces that are visible from local surfaces (i.e. there is a SVF
 !>    where target is local). To do that, radiosity will be exchanged after each
 !>    reflection step using MPI_Alltoall instead of current MPI_Allgather.
 !>
-!> 3. Temporarily large values of surface heat flux can be observed, up to
+!> 2. Temporarily large values of surface heat flux can be observed, up to
 !>    1.2 Km/s, which seem to be not realistic.
 !>
@@ -248,5 +250,5 @@
 #if ! defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend
+        ONLY:  hyp, zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend
 #endif
 
@@ -272,5 +274,5 @@
 
     USE date_and_time_mod,                                                     &
-        ONLY:  d_seconds_year, day_of_year_init, time_utc_init
+        ONLY:  time_utc_init
 
     USE grid_variables,                                                        &
@@ -288,8 +290,8 @@
     
     USE plant_canopy_model_mod,                                                &
-        ONLY:  pc_heating_rate, usm_lad_rma
+        ONLY:  pc_heating_rate
     
     USE radiation_model_mod,                                                   &
-        ONLY:  albedo_type, radiation, calc_zenith, zenith,                    &
+        ONLY:  albedo_type, radiation_interaction, calc_zenith, zenith,                    &
                rad_sw_in, rad_lw_in, rad_sw_out, rad_lw_out,                   &
                sigma_sb, solar_constant, sun_direction, sun_dir_lat,           &
@@ -297,14 +299,14 @@
                force_radiation_call, surfinsw, surfinlw, surfinswdir,          &
                surfinswdif, surfoutsw, surfoutlw, surfins,nsvfl, svf, svfsurf, &
-               surfinl, surfinlwdif, energy_balance_surf_h,                    &
-               energy_balance_surf_v, rad_sw_in_dir, rad_sw_in_diff,           &
+               surfinl, surfinlwdif, rad_sw_in_dir, rad_sw_in_diff,            &
                rad_lw_in_diff, surfouts, surfoutl, surfoutsl, surfoutll, surf, &
-               surfl, nsurfl, nsurfs, surfstart, pcbinsw, pcbinlw, pcbl, npcbl, startenergy,      &
-               endenergy, nenergy, iup_u, inorth_u, isouth_u, ieast_u, iwest_u, iup_l,  &
-               inorth_l, isouth_l, ieast_l, iwest_l, startsky, endsky,id,      &
-               iz, iy, ix, idir, jdir, kdir, startborder, endborder, nsurf_type, nzub, nzut,   &
-               isky, inorth_b,idown_a, isouth_b, ieast_b, iwest_b, nzu, pch, nsurf,  &
-               iup_a, inorth_a, isouth_a, ieast_a, iwest_a, idsvf, ndsvf,      &
-               idcsf, ndcsf, kdcsf, pct, startland, endland, startwall, endwall
+               surfl, nsurfl, nsurfs, surfstart, pcbinsw, pcbinlw,             &
+               iup_u, inorth_u, isouth_u, ieast_u, iwest_u, iup_l,             &
+               inorth_l, isouth_l, ieast_l, iwest_l, id,                       &
+               iz, iy, ix, idir, jdir, kdir,  nsurf_type, nzub, nzut,          &
+               nzu, pch, nsurf, idsvf, ndsvf,                                  &
+               iup_a, idown_a, inorth_a, isouth_a, ieast_a, iwest_a,           &
+               idcsf, ndcsf, kdcsf, pct,                                       &
+               startland, endland, startwall, endwall, skyvf, skyvft
 
     USE statistics,                                                            &
@@ -322,12 +324,13 @@
     LOGICAL                                        ::  force_radiation_call_l = .FALSE.   !< flag parameter for unscheduled radiation model calls
     LOGICAL                                        ::  indoor_model = .FALSE.              !< whether to use the indoor model
-
-   
+    LOGICAL                                        ::  read_wall_temp_3d = .FALSE.
+
+
     INTEGER(iwp)                                   ::  building_type = 1                  !< default building type (preleminary setting)
     INTEGER(iwp)                                   ::  land_category = 2                  !< default category for land surface
     INTEGER(iwp)                                   ::  wall_category = 2                  !< default category for wall surface over pedestrian zone
-    INTEGER(iwp)                                   ::  pedestrant_category = 2            !< default category for wall surface in pedestrian zone
+    INTEGER(iwp)                                   ::  pedestrian_category = 2            !< default category for wall surface in pedestrian zone
     INTEGER(iwp)                                   ::  roof_category = 2                  !< default category for root surface
-
+    REAL(wp)                                       ::  roughness_concrete = 0.001_wp      !< roughness length of average concrete surface
 !
 !-- Indices of input attributes for (above) ground floor level 
@@ -380,6 +383,5 @@
     REAL(wp)  ::  roof_height_limit = 4._wp          !< height for distinguish between land surfaces and roofs
     REAL(wp)  ::  ground_floor_level = 4.0_wp        !< default ground floor level
-    REAL(wp)  ::  ra_horiz_coef = 5.0_wp             !< mysterious coefficient for correction of overestimation
-                                                                                          !< of r_a for horizontal surfaces -> TODO
+
 
     CHARACTER(37), DIMENSION(0:6), PARAMETER :: building_type_name = (/     &
@@ -524,6 +526,7 @@
 !-- anthropogenic heat sources
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheat             !< daily average of anthropogenic heat (W/m2)
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  aheatprof         !< diurnal profile of anthropogenic heat 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE        ::  aheat             !< daily average of anthropogenic heat (W/m2)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheatprof         !< diurnal profiles of anthropogenic heat for particular layers
+    INTEGER(wp)                                    ::  naheatlayers = 1  !< number of layers of anthropogenic heat
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -547,9 +550,9 @@
 !    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.33_wp, 0.66_wp, 1.0_wp /)
 
-                                                                        
-    REAL(wp)                                       ::   wall_inner_temperature = 296.0_wp    !< temperature of the inner wall surface (~23 degrees C) (K)
-    REAL(wp)                                       ::   roof_inner_temperature = 296.0_wp    !< temperature of the inner roof surface (~23 degrees C) (K)
-    REAL(wp)                                       ::   soil_inner_temperature = 283.0_wp    !< temperature of the deep soil (~10 degrees C) (K)
-    REAL(wp)                                       ::   window_inner_temperature = 296.0_wp  !< temperature of the inner window surface (~23 degrees C) (K)
+
+    REAL(wp)                                       :: wall_inner_temperature = 295.0_wp    !< temperature of the inner wall surface (~22 degrees C) (K)
+    REAL(wp)                                       :: roof_inner_temperature = 295.0_wp    !< temperature of the inner roof surface (~22 degrees C) (K)
+    REAL(wp)                                       :: soil_inner_temperature = 288.0_wp    !< temperature of the deep soil (~15 degrees C) (K)
+    REAL(wp)                                       :: window_inner_temperature = 295.0_wp  !< temperature of the inner window surface (~22 degrees C) (K)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -674,13 +677,14 @@
 !-- albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
     INTEGER(iwp)                                   :: n_surface_types      !< number of the wall type categories
-    INTEGER(iwp), PARAMETER                        :: n_surface_params = 8 !< number of parameters for each type of the wall
+    INTEGER(iwp), PARAMETER                        :: n_surface_params = 9 !< number of parameters for each type of the wall
     INTEGER(iwp), PARAMETER                        :: ialbedo  = 1         !< albedo of the surface
     INTEGER(iwp), PARAMETER                        :: iemiss   = 2         !< emissivity of the surface
-    INTEGER(iwp), PARAMETER                        :: ilambdas = 3         !< heat conductivity Î»S between air and surface ( W mâ2 Kâ1 )
-    INTEGER(iwp), PARAMETER                        :: irough   = 4         !< roughness relative to concrete
-    INTEGER(iwp), PARAMETER                        :: icsurf   = 5         !< Surface skin layer heat capacity (J mâ2 Kâ1 )
-    INTEGER(iwp), PARAMETER                        :: ithick   = 6         !< thickness of the surface (wall, roof, land)  ( m )
-    INTEGER(iwp), PARAMETER                        :: irhoC    = 7         !< volumetric heat capacity rho*C of the material ( J mâ3 Kâ1 )
-    INTEGER(iwp), PARAMETER                        :: ilambdah = 8         !< thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
+    INTEGER(iwp), PARAMETER                        :: ilambdas = 3         !< heat conductivity lambda S between surface and material ( W m-2 K-1 )
+    INTEGER(iwp), PARAMETER                        :: irough   = 4         !< roughness length z0 for movements
+    INTEGER(iwp), PARAMETER                        :: iroughh  = 5         !< roughness length z0h for scalars (heat, humidity,...)
+    INTEGER(iwp), PARAMETER                        :: icsurf   = 6         !< Surface skin layer heat capacity (J m-2 K-1 )
+    INTEGER(iwp), PARAMETER                        :: ithick   = 7         !< thickness of the surface (wall, roof, land)  ( m )
+    INTEGER(iwp), PARAMETER                        :: irhoC    = 8         !< volumetric heat capacity rho*C of the material ( J m-3 K-1 )
+    INTEGER(iwp), PARAMETER                        :: ilambdah = 9         !< thermal conductivity lambda H of the wall (W m-1 K-1 )
     CHARACTER(12), DIMENSION(:), ALLOCATABLE       :: surface_type_names   !< names of wall types (used only for reports)
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_type_codes   !< codes of wall types
@@ -760,12 +764,12 @@
 !-- Public functions
     PUBLIC usm_boundary_condition, usm_check_parameters, usm_init_urban_surface,&
-           usm_rrd_local,                                                       & 
-           usm_surface_energy_balance, usm_material_heat_model,                 &
-           usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,      &
-           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,               &
+           usm_rrd_local,                                                      & 
+           usm_surface_energy_balance, usm_material_heat_model,                &
+           usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,     &
+           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,              &
            usm_wrd_local, usm_allocate_surface
 
 !-- Public parameters, constants and initial values
-    PUBLIC usm_anthropogenic_heat, usm_material_model, ra_horiz_coef,           &
+    PUBLIC usm_anthropogenic_heat, usm_material_model,                          &
            usm_green_heat_model, usm_temperature_near_surface
 
@@ -1175,8 +1179,9 @@
         CHARACTER (len=*), INTENT(IN) :: variable
   
-        INTEGER(iwp)                                       :: i, j, k, l, m, ids, iwl,istat
+        INTEGER(iwp)                                       :: i, j, k, l, m, ids, idsint, iwl, istat
         CHARACTER (len=varnamelength)                      :: var, surfid
         INTEGER(iwp), PARAMETER                            :: nd = 5
         CHARACTER(len=6), DIMENSION(0:nd-1), PARAMETER     :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
+        INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         :: dirint = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
 
 !--     find the real name of the variable
@@ -1188,4 +1193,5 @@
             IF ( var(k-j+1:k) == dirname(i) )  THEN
                 ids = i
+                idsint = dirint(ids)
                 var = var(:k-j)
                 EXIT
@@ -1245,32 +1251,20 @@
                 CASE ( 'usm_rad_insw' )
 !--                 array of sw radiation falling to surface after i-th reflection
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%surfinsw_av) )  THEN
-                        ALLOCATE( surf_usm_h%surfinsw_av(1:surf_usm_h%ns) )
-                        surf_usm_h%surfinsw_av = 0.0_wp
+                    IF ( .NOT.  ALLOCATED(surfinsw_av) )  THEN
+                        ALLOCATE( surfinsw_av(nsurfl) )
+                        surfinsw_av = 0.0_wp
                     ENDIF
-                    DO  l = 0, 3
-                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%surfinsw_av) )  THEN
-                           ALLOCATE( surf_usm_v(l)%surfinsw_av(1:surf_usm_v(l)%ns) )
-                           surf_usm_v(l)%surfinsw_av = 0.0_wp
-                       ENDIF
-                    ENDDO
-                                    
+
                 CASE ( 'usm_rad_inlw' )
 !--                 array of lw radiation falling to surface after i-th reflection
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%surfinlw_av) )  THEN
-                        ALLOCATE( surf_usm_h%surfinlw_av(1:surf_usm_h%ns) )
-                        surf_usm_h%surfinlw_av = 0.0_wp
+                    IF ( .NOT.  ALLOCATED(surfinlw_av) )  THEN
+                        ALLOCATE( surfinlw_av(nsurfl) )
+                        surfinlw_av = 0.0_wp
                     ENDIF
-                    DO  l = 0, 3
-                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%surfinlw_av) )  THEN
-                           ALLOCATE( surf_usm_v(l)%surfinlw_av(1:surf_usm_v(l)%ns) )
-                           surf_usm_v(l)%surfinlw_av = 0.0_wp
-                       ENDIF
-                    ENDDO
 
                 CASE ( 'usm_rad_inswdir' )
 !--                 array of direct sw radiation falling to surface from sun
                     IF ( .NOT.  ALLOCATED(surfinswdir_av) )  THEN
-                        ALLOCATE( surfinswdir_av(startenergy:endenergy) )
+                        ALLOCATE( surfinswdir_av(nsurfl) )
                         surfinswdir_av = 0.0_wp
                     ENDIF
@@ -1279,5 +1273,5 @@
 !--                 array of difusion sw radiation falling to surface from sky and borders of the domain
                     IF ( .NOT.  ALLOCATED(surfinswdif_av) )  THEN
-                        ALLOCATE( surfinswdif_av(startenergy:endenergy) )
+                        ALLOCATE( surfinswdif_av(nsurfl) )
                         surfinswdif_av = 0.0_wp
                     ENDIF
@@ -1286,5 +1280,5 @@
 !--                 array of sw radiation falling to surface from reflections
                     IF ( .NOT.  ALLOCATED(surfinswref_av) )  THEN
-                        ALLOCATE( surfinswref_av(startenergy:endenergy) )
+                        ALLOCATE( surfinswref_av(nsurfl) )
                         surfinswref_av = 0.0_wp
                     ENDIF
@@ -1293,5 +1287,5 @@
 !--                 array of sw radiation falling to surface after i-th reflection
                    IF ( .NOT.  ALLOCATED(surfinlwdif_av) )  THEN
-                        ALLOCATE( surfinlwdif_av(startenergy:endenergy) )
+                        ALLOCATE( surfinlwdif_av(nsurfl) )
                         surfinlwdif_av = 0.0_wp
                     ENDIF
@@ -1300,5 +1294,5 @@
 !--                 array of lw radiation falling to surface from reflections
                     IF ( .NOT.  ALLOCATED(surfinlwref_av) )  THEN
-                        ALLOCATE( surfinlwref_av(startenergy:endenergy) )
+                        ALLOCATE( surfinlwref_av(nsurfl) )
                         surfinlwref_av = 0.0_wp
                     ENDIF
@@ -1307,5 +1301,5 @@
 !--                 array of sw radiation emitted from surface after i-th reflection
                     IF ( .NOT.  ALLOCATED(surfoutsw_av) )  THEN
-                        ALLOCATE( surfoutsw_av(startenergy:endenergy) )
+                        ALLOCATE( surfoutsw_av(nsurfl) )
                         surfoutsw_av = 0.0_wp
                     ENDIF
@@ -1314,5 +1308,5 @@
 !--                 array of lw radiation emitted from surface after i-th reflection
                     IF ( .NOT.  ALLOCATED(surfoutlw_av) )  THEN
-                        ALLOCATE( surfoutlw_av(startenergy:endenergy) )
+                        ALLOCATE( surfoutlw_av(nsurfl) )
                         surfoutlw_av = 0.0_wp
                     ENDIF
@@ -1320,5 +1314,5 @@
 !--                 array of residua of sw radiation absorbed in surface after last reflection
                     IF ( .NOT.  ALLOCATED(surfins_av) )  THEN
-                        ALLOCATE( surfins_av(startenergy:endenergy) )
+                        ALLOCATE( surfins_av(nsurfl) )
                         surfins_av = 0.0_wp
                     ENDIF
@@ -1327,5 +1321,5 @@
 !--                 array of residua of lw radiation absorbed in surface after last reflection
                     IF ( .NOT.  ALLOCATED(surfinl_av) )  THEN
-                        ALLOCATE( surfinl_av(startenergy:endenergy) )
+                        ALLOCATE( surfinl_av(nsurfl) )
                         surfinl_av = 0.0_wp
                     ENDIF
@@ -1544,6 +1538,6 @@
                 CASE ( 'usm_rad_insw' )
 !--                 array of sw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinsw_av(l) = surfinsw_av(l) + surfinsw(l)
                         ENDIF
@@ -1552,6 +1546,6 @@
                 CASE ( 'usm_rad_inlw' )
 !--                 array of lw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinlw_av(l) = surfinlw_av(l) + surfinlw(l)
                         ENDIF
@@ -1560,6 +1554,6 @@
                 CASE ( 'usm_rad_inswdir' )
 !--                 array of direct sw radiation falling to surface from sun
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswdir_av(l) = surfinswdir_av(l) + surfinswdir(l)
                         ENDIF
@@ -1568,6 +1562,6 @@
                 CASE ( 'usm_rad_inswdif' )
 !--                 array of difusion sw radiation falling to surface from sky and borders of the domain
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswdif_av(l) = surfinswdif_av(l) + surfinswdif(l)
                         ENDIF
@@ -1576,6 +1570,6 @@
                 CASE ( 'usm_rad_inswref' )
 !--                 array of sw radiation falling to surface from reflections
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswref_av(l) = surfinswref_av(l) + surfinsw(l) - &
                                                 surfinswdir(l) - surfinswdif(l)
@@ -1586,8 +1580,7 @@
                 CASE ( 'usm_rad_inlwdif' )
 !--                 array of sw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfinswref_av(l) = surfinswref_av(l) + surfinsw(l) - &
-                                                surfinswdir(l) - surfinswdif(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfinlwdif_av(l) = surfinlwdif_av(l) + surfinlwdif(l)
                         ENDIF
                     ENDDO
@@ -1595,7 +1588,8 @@
                 CASE ( 'usm_rad_inlwref' )
 !--                 array of lw radiation falling to surface from reflections
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfinlwdif_av(l) = surfinlwdif_av(l) + surfinlwdif(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfinlwref_av(l) = surfinlwref_av(l) + &
+                                                surfinlw(l) - surfinlwdif(l)
                         ENDIF
                     ENDDO
@@ -1603,8 +1597,7 @@
                 CASE ( 'usm_rad_outsw' )
 !--                 array of sw radiation emitted from surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfinlwref_av(l) = surfinlwref_av(l) + &
-                                                surfinlw(l) - surfinlwdif(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfoutsw_av(l) = surfoutsw_av(l) + surfoutsw(l)
                         ENDIF
                     ENDDO
@@ -1612,7 +1605,7 @@
                 CASE ( 'usm_rad_outlw' )
 !--                 array of lw radiation emitted from surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfoutsw_av(l) = surfoutsw_av(l) + surfoutsw(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfoutlw_av(l) = surfoutlw_av(l) + surfoutlw(l)
                         ENDIF
                     ENDDO
@@ -1620,7 +1613,7 @@
                 CASE ( 'usm_rad_ressw' )
 !--                 array of residua of sw radiation absorbed in surface after last reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfoutlw_av(l) = surfoutlw_av(l) + surfoutlw(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfins_av(l) = surfins_av(l) + surfins(l)
                         ENDIF
                     ENDDO
@@ -1628,7 +1621,7 @@
                 CASE ( 'usm_rad_reslw' )
 !--                 array of residua of lw radiation absorbed in surface after last reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
-                            surfins_av(l) = surfins_av(l) + surfins(l)
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
+                            surfinl_av(l) = surfinl_av(l) + surfinl(l)
                         ENDIF
                     ENDDO
@@ -1871,6 +1864,6 @@
                 CASE ( 'usm_rad_insw' )
 !--                 array of sw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinsw_av(l) = surfinsw_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1879,6 +1872,6 @@
                 CASE ( 'usm_rad_inlw' )
 !--                 array of lw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinlw_av(l) = surfinlw_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1887,6 +1880,6 @@
                 CASE ( 'usm_rad_inswdir' )
 !--                 array of direct sw radiation falling to surface from sun
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswdir_av(l) = surfinswdir_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1895,6 +1888,6 @@
                 CASE ( 'usm_rad_inswdif' )
 !--                 array of difusion sw radiation falling to surface from sky and borders of the domain
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswdif_av(l) = surfinswdif_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1903,6 +1896,6 @@
                 CASE ( 'usm_rad_inswref' )
 !--                 array of sw radiation falling to surface from reflections
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinswref_av(l) = surfinswref_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1911,6 +1904,6 @@
                 CASE ( 'usm_rad_inlwdif' )
 !--                 array of sw radiation falling to surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinlwdif_av(l) = surfinlwdif_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1919,6 +1912,6 @@
                 CASE ( 'usm_rad_inlwref' )
 !--                 array of lw radiation falling to surface from reflections
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinlwref_av(l) = surfinlwref_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1927,6 +1920,6 @@
                 CASE ( 'usm_rad_outsw' )
 !--                 array of sw radiation emitted from surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfoutsw_av(l) = surfoutsw_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1935,6 +1928,6 @@
                 CASE ( 'usm_rad_outlw' )
 !--                 array of lw radiation emitted from surface after i-th reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfoutlw_av(l) = surfoutlw_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1943,6 +1936,6 @@
                 CASE ( 'usm_rad_ressw' )
 !--                 array of residua of sw radiation absorbed in surface after last reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfins_av(l) = surfins_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -1951,6 +1944,6 @@
                 CASE ( 'usm_rad_reslw' )
 !--                 array of residua of lw radiation absorbed in surface after last reflection
-                    DO l = startenergy, endenergy
-                        IF ( surfl(id,l) == ids )  THEN
+                    DO l = 1, nsurfl
+                        IF ( surfl(id,l) == idsint )  THEN
                             surfinl_av(l) = surfinl_av(l) / REAL( average_count_3d, kind=wp )
                         ENDIF
@@ -2245,5 +2238,5 @@
              var(1:10) == 'usm_iwghf_' .OR. var(1:17) == 'usm_iwghf_window_' )  THEN
             unit = 'W/m2'
-        ELSE IF ( var(1:10) == 'usm_t_surf'  .OR.  var(1:10) == 'usm_t_wall' .OR.         &
+        ELSE IF ( var(1:10) == 'usm_t_surf'   .OR.  var(1:10) == 'usm_t_wall' .OR.         &
                   var(1:12) == 'usm_t_window' .OR. var(1:17) == 'usm_t_surf_window' .OR.  &
                   var(1:16) == 'usm_t_surf_green'  .OR.                                   &
@@ -2253,5 +2246,6 @@
         ELSE IF ( var(1:9) == 'usm_surfz'  .OR.  var(1:7) == 'usm_svf'  .OR.              & 
                   var(1:7) == 'usm_dif'  .OR.  var(1:11) == 'usm_surfcat'  .OR.           &
-                  var(1:11) == 'usm_surfalb'  .OR.  var(1:12) == 'usm_surfemis')  THEN
+                  var(1:11) == 'usm_surfalb'  .OR.  var(1:12) == 'usm_surfemis'  .OR.     &
+                  var(1:9) == 'usm_skyvf' .OR. var(1:9) == 'usm_skyvft' )  THEN
             unit = '1'
         ELSE
